#!/usr/bin/env ruby

#
# WPScan - WordPress Security Scanner
# Copyright (C) 2011  Ryan Dewhurst AKA ethicalhack3r
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# ryandewhurst at gmail
#

class Update

  def initialize
  end

  # Main update logic

  def update

    if svn_installed?

      return false if remote_revision == false

      if remote_revision != local_revision

        puts "[?] An update is available. Update to rev " + remote_revision  + "? [y/n]"
        answer = Readline.readline

        if answer =~ /^y/i
          svn_up
          puts
          puts "Updated to revision " + remote_revision
          puts 
          return true
        else
          return false
        end

      end

    end

    return false
  end

  # Check if SVN is installed

  def svn_installed?
    svn = %x[svn > /dev/null 2>&1]
  end

  # Run asvn update

  def svn_up
    svn_up = %x[svn up &> /dev/null]
  end

  # Find the local revision

  def local_revision
    local_revision = `svn info --xml`
    local_revision = local_revision.scan(/revision="(\d+)"/i)[0][0].to_s
  end

  # Find the latest revision

  def remote_revision
    begin
      remote_revision = `svn info https://wpscan.googlecode.com/svn/trunk --xml 2> /dev/null`
      remote_revision = remote_revision.scan(/revision="(\d+)"/i)[0][0].to_s
    rescue
      return false
    end
  end

end
